package com.gic.cloud.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.cloud.dto.UserDTO;
import com.gic.cloud.service.UserApiService;
import com.gic.cloud.web.constant.ErrorCode;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.utils.CreateRandomUtils;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.marketing.process.api.service.sms.SmsSendApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
public class LoginController {
    private static final Logger log = LogManager.getLogger(LoginController.class);

    @Autowired
    private UserApiService userApiService;
    @Autowired
    private SmsSendApiService smsSendApiService;

    @RequestMapping("send-code")
    public RestResponse sendCode(String phoneNumber, String areaCode){
        String smsSenceId = "GYT0001";
        List<UserDTO> userDTOList = this.userApiService.listUserByPhone("86", phoneNumber).getResult();
        if(CollectionUtils.isNotEmpty(userDTOList)){
            Integer enterpriseId = userDTOList.get(0).getEnterpriseId();
            ServiceResponse<Void> smsSendResult = smsSendApiService.sendPlatformSms(smsSenceId,
                    enterpriseId,areaCode, phoneNumber, new String[]{CreateRandomUtils.getStringRandom(4)});
            if(smsSendResult.isSuccess()){
                return RestResponse.success();
            }else {
                return RestResponse.failure(ErrorCode.SYSTEMERROR.getCode(), smsSendResult.getMessage());
            }
        }else {
            return RestResponse.failure(ErrorCode.ACCOUNTNOTEXISTS.getCode(), ErrorCode.ACCOUNTNOTEXISTS.getMsg());
        }
    }
}
